/*
 * ckstrip: .x t@CXgbvꂽǂׂ
 * Copyright (C) 1995  씎Y(oo) <HGG00736@niftyserve.or.jp>
 */
#include <stdio.h>
#include <a_out.h>
#include "error.h"

int	f_and, f_help, f_quiet, f_short, f_verbose, f_version;

int main(int argc, char**argv)
{
	int ret_code = 0;
	char* opts;
	FILE* fp;
	struct aouthdr header;

	set_progname(*argv);

	while (argv[1] && argv[1][0] == '-') {
		for (opts = argv[1] + 1; *opts; opts++) {
			switch (*opts) {
			case 'a': f_and = 1; break;
			case 'o': f_and = 0; break;
			case 'q': f_quiet = 1; f_verbose = 0; break;
			case 'V': f_version = 1; break;
			case 's': f_short = 1; f_quiet = 0; f_verbose = 0; break;
			case 'v': f_verbose = 1; f_quiet = 0; break;
			case 'h':
			default : f_help = 1; break;
			}
		}
		--argc, ++argv;
	}
	if (f_version) {
		fprintf(stderr, "%s ver1.0  1995 (C) oo\n", progname);
		if (argc == 1) return 0;
	}
	if (argc <= 1 || f_help) {
		fprintf(stderr, "gp@F %s [-ao] file.x[ file.x]\n", progname);
		return -1;
	}

	while (--argc > 0) {
		if (fp = fopen(*++argv, "rb")) {
			if (fread((void*)&header, sizeof(struct aouthdr), 1, fp) == 1) {
				if (header.magic == XMAGIC) {
					if (header.symbol) {
						if (!f_and) ret_code &= ~1;
						if (!f_quiet) printf(f_short ? "%s ": "%s is not striped executable.\n", *argv);
					}
					else {
						if (f_and) ret_code |= 1;
						if (f_verbose) printf("%s is striped executable.\n", *argv);
					}
				}
				else {
					ret_code |= 2;
					error("illegal .x magic %s", *argv);
				}
			}
			else {
				ret_code |= 2;
				error("cannot read %s", *argv);
			}
			fclose(fp);
		}
		else {
			ret_code |= 2;
			error("cannot open %s", *argv);
		}
	}
	if (f_short) fputc('\n', stdout);
	return ret_code;
}
